/* WARNING: THIS FILE IS AUTOMATICALLY GENERATED FROM A .SM FILE.
 * Changes made here will most likely be overwritten.
 */

/* 
 * (C) 2001 Clemson University and The University of Chicago 
 *
 * See COPYING in top-level directory.
 */

#include <string.h>
#include <assert.h>

#include "server-config.h"
#include "pvfs2-storage.h"
#include "pvfs2-server.h"
#include "pvfs2-attr.h"
#include "gossip.h"

static int mgmt_get_dirdata_handle_from_parent(
    PINT_server_op *s_op, job_status_s *js_p);
static int mgmt_get_dirdata_handle_setup_resp(
    PINT_server_op *s_op, job_status_s *js_p);
static int mgmt_get_dirdata_handle_cleanup(
    PINT_server_op *s_op, job_status_s *js_p);

extern PINT_server_trove_keys_s Trove_Common_Keys[];

extern union PINT_state_array_values ST_prelude[];
extern union PINT_state_array_values ST_get_dirdata_handle_from_parent[];
extern union PINT_state_array_values ST_get_dirdata_handle_setup_resp[];
extern union PINT_state_array_values ST_final_response[];
extern union PINT_state_array_values ST_cleanup[];

struct PINT_state_machine_s pvfs2_mgmt_get_dirdata_handle_sm =
{
	ST_prelude,
	"pvfs2_mgmt_get_dirdata_handle_sm"
};
static union PINT_state_array_values ST_prelude[] = {
(union PINT_state_array_values) 6,
(union PINT_state_array_values) &pvfs2_prelude_sm,
(union PINT_state_array_values) 0,
(union PINT_state_array_values) ST_get_dirdata_handle_from_parent,
(union PINT_state_array_values) -1,
(union PINT_state_array_values) ST_final_response
};

static union PINT_state_array_values ST_get_dirdata_handle_from_parent[] = {
(union PINT_state_array_values) 0,
(union PINT_state_array_values) mgmt_get_dirdata_handle_from_parent,
(union PINT_state_array_values) 0,
(union PINT_state_array_values) ST_get_dirdata_handle_setup_resp,
(union PINT_state_array_values) -1,
(union PINT_state_array_values) ST_final_response
};

static union PINT_state_array_values ST_get_dirdata_handle_setup_resp[] = {
(union PINT_state_array_values) 0,
(union PINT_state_array_values) mgmt_get_dirdata_handle_setup_resp,
(union PINT_state_array_values) -1,
(union PINT_state_array_values) ST_final_response
};

static union PINT_state_array_values ST_final_response[] = {
(union PINT_state_array_values) 6,
(union PINT_state_array_values) &pvfs2_final_response_sm,
(union PINT_state_array_values) -1,
(union PINT_state_array_values) ST_cleanup
};

static union PINT_state_array_values ST_cleanup[] = {
(union PINT_state_array_values) 0,
(union PINT_state_array_values) mgmt_get_dirdata_handle_cleanup,
(union PINT_state_array_values) -1,
(union PINT_state_array_values) 7
};

# 67 "src/server/mgmt-get-dirdata-handle.sm"


static int mgmt_get_dirdata_handle_from_parent(
    PINT_server_op *s_op, job_status_s *js_p)
{
    int ret = -PVFS_EINVAL;
    job_id_t i;

    PINT_STATE_DEBUG("mgmt_get_dirdata_handle_from_parent");

    s_op->key.buffer = Trove_Common_Keys[DIR_ENT_KEY].key;
    s_op->key.buffer_sz = Trove_Common_Keys[DIR_ENT_KEY].size;

    s_op->val.buffer = &s_op->u.mgmt_get_dirdata_handle.dirdata_handle;
    s_op->val.buffer_sz = sizeof(PVFS_handle);

    gossip_debug(
        GOSSIP_SERVER_DEBUG,
        "  reading dirdata handle (coll_id = %d, handle = %Lu\n\t"
        "key = %s (%d), val_buf = %p (%d))\n",
        s_op->req->u.mgmt_get_dirdata_handle.fs_id,
        Lu(s_op->req->u.mgmt_get_dirdata_handle.handle),
        (char *)s_op->key.buffer, s_op->key.buffer_sz,
        s_op->val.buffer, s_op->val.buffer_sz);

    ret = job_trove_keyval_read(
        s_op->req->u.mgmt_get_dirdata_handle.fs_id,
        s_op->req->u.mgmt_get_dirdata_handle.handle,
        &s_op->key, &s_op->val, 0, NULL, s_op, 0, js_p, &i,
        server_job_context);

    return ret;
}

static int mgmt_get_dirdata_handle_setup_resp(
    PINT_server_op *s_op, job_status_s *js_p)
{
    PINT_STATE_DEBUG("mgmt_get_dirdata_handle_setup_resp");

    if (js_p->error_code == 0)
    {
        s_op->resp.u.mgmt_get_dirdata_handle.handle =
            s_op->u.mgmt_get_dirdata_handle.dirdata_handle;

        gossip_debug(
            GOSSIP_SERVER_DEBUG, "  Found dirdata handle %Lu of parent "
            "%Lu\n", Lu(s_op->u.mgmt_get_dirdata_handle.dirdata_handle),
            Lu(s_op->req->u.mgmt_get_dirdata_handle.handle));
    }
    else
    {
        s_op->resp.u.mgmt_get_dirdata_handle.handle = PVFS_HANDLE_NULL;

        gossip_debug(GOSSIP_SERVER_DEBUG, "Failed to retrieve dirdata "
                     "handle from parent %Lu\n",
                     Lu(s_op->req->u.mgmt_get_dirdata_handle.handle));
    }
    return 1;
}

static int mgmt_get_dirdata_handle_cleanup(
    PINT_server_op *s_op, job_status_s *js_p)
{
    PINT_STATE_DEBUG("mgmt_get_dirdata_handle_cleanup");
    return(server_state_machine_complete(s_op));
}

/*
 * Local variables:
 *  mode: c
 *  c-indent-level: 4
 *  c-basic-offset: 4
 * End:
 *
 * vim: ft=c ts=8 sts=4 sw=4 expandtab
 */
