/* WARNING: THIS FILE IS AUTOMATICALLY GENERATED FROM A .SM FILE.
 * Changes made here will most likely be overwritten.
 */

/* 
 * (C) 2001 Clemson University and The University of Chicago 
 *
 * See COPYING in top-level directory.
 */
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/time.h>

#include "pvfs2-server.h"
#include "pint-perf-counter.h"

static int perf_mon_cleanup(PINT_server_op *s_op, job_status_s* js_p);
static int perf_mon_do_work(PINT_server_op *s_op, job_status_s* js_p);

extern union PINT_state_array_values ST_prelude[];
extern union PINT_state_array_values ST_do_work[];
extern union PINT_state_array_values ST_final_response[];
extern union PINT_state_array_values ST_cleanup[];

struct PINT_state_machine_s pvfs2_perf_mon_sm =
{
	ST_prelude,
	"pvfs2_perf_mon_sm"
};
static union PINT_state_array_values ST_prelude[] = {
(union PINT_state_array_values) 6,
(union PINT_state_array_values) &pvfs2_prelude_sm,
(union PINT_state_array_values) -1,
(union PINT_state_array_values) ST_do_work
};

static union PINT_state_array_values ST_do_work[] = {
(union PINT_state_array_values) 0,
(union PINT_state_array_values) perf_mon_do_work,
(union PINT_state_array_values) -1,
(union PINT_state_array_values) ST_final_response
};

static union PINT_state_array_values ST_final_response[] = {
(union PINT_state_array_values) 6,
(union PINT_state_array_values) &pvfs2_final_response_sm,
(union PINT_state_array_values) -1,
(union PINT_state_array_values) ST_cleanup
};

static union PINT_state_array_values ST_cleanup[] = {
(union PINT_state_array_values) 0,
(union PINT_state_array_values) perf_mon_cleanup,
(union PINT_state_array_values) -1,
(union PINT_state_array_values) 7
};

# 49 "src/server/perf-mon.sm"


/* perf_mon_cleanup()
 *
 * cleans up any resources consumed by this state machine and ends
 * execution of the machine
 */
static int perf_mon_cleanup(PINT_server_op *s_op, job_status_s* js_p)
{
    PINT_STATE_DEBUG("cleanup");

    if(s_op->resp.u.mgmt_perf_mon.perf_array)
	free(s_op->resp.u.mgmt_perf_mon.perf_array);

    return(server_state_machine_complete(s_op));
}

/* perf_mon_do_work()
 *
 * gathers statistics and builds response
 */
static int perf_mon_do_work(PINT_server_op *s_op, job_status_s* js_p)
{
    struct timeval tv;

    PINT_STATE_DEBUG("do_work");

#ifdef __PVFS2_DISABLE_PERF_COUNTERS__
    gossip_err("Error: perf_mon request received, but perf counters are disabled.\n");
    js_p->error_code = -PVFS_ENOSYS;
    return(1);
#endif

    /* allocate memory to hold statistics */
    s_op->resp.u.mgmt_perf_mon.perf_array 
	= (struct PVFS_mgmt_perf_stat*)malloc(s_op->req->u.mgmt_perf_mon.count *
	sizeof(struct PVFS_mgmt_perf_stat));
    if(!s_op->resp.u.mgmt_perf_mon.perf_array)
    {
	js_p->error_code = -PVFS_ENOMEM;
	return(1);
    }

    /* fill in some of the response */
    gettimeofday(&tv, NULL);
    s_op->resp.u.mgmt_perf_mon.cur_time_ms = tv.tv_sec*1000 + 
	tv.tv_usec/1000;
    s_op->resp.u.mgmt_perf_mon.suggested_next_id 
	= s_op->req->u.mgmt_perf_mon.next_id;
    s_op->resp.u.mgmt_perf_mon.perf_array_count
	= s_op->req->u.mgmt_perf_mon.count;

    /* get statistics */
    PINT_perf_retrieve(&s_op->resp.u.mgmt_perf_mon.suggested_next_id,
	s_op->resp.u.mgmt_perf_mon.perf_array,
	s_op->resp.u.mgmt_perf_mon.perf_array_count,
	&s_op->resp.u.mgmt_perf_mon.end_time_ms);

    js_p->error_code = 0;
    return(1);
}



/*
 * Local variables:
 *  mode: c
 *  c-indent-level: 4
 *  c-basic-offset: 4
 * End:
 *
 * vim: ft=c ts=8 sts=4 sw=4 expandtab
 */

