/* WARNING: THIS FILE IS AUTOMATICALLY GENERATED FROM A .SM FILE.
 * Changes made here will most likely be overwritten.
 */

/* 
 * (C) 2001 Clemson University and The University of Chicago 
 *
 * See COPYING in top-level directory.
 */
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/time.h>

#include "pvfs2-server.h"
#include "pint-perf-counter.h"
#include "server-config.h"

static int perf_update_do_work(PINT_server_op *s_op, job_status_s* js_p);
static int perf_update_error(PINT_server_op *s_op, job_status_s* js_p);

extern union PINT_state_array_values ST_do_work[];
extern union PINT_state_array_values ST_error[];

struct PINT_state_machine_s pvfs2_perf_update_sm =
{
	ST_do_work,
	"pvfs2_perf_update_sm"
};
static union PINT_state_array_values ST_do_work[] = {
(union PINT_state_array_values) 0,
(union PINT_state_array_values) perf_update_do_work,
(union PINT_state_array_values) 0,
(union PINT_state_array_values) ST_do_work,
(union PINT_state_array_values) -1,
(union PINT_state_array_values) ST_error
};

static union PINT_state_array_values ST_error[] = {
(union PINT_state_array_values) 0,
(union PINT_state_array_values) perf_update_error,
(union PINT_state_array_values) -1,
(union PINT_state_array_values) 7
};

# 39 "src/server/perf-update.sm"


/* perf_update_error()
 *
 * cleans up any resources consumed by this state machine and ends
 * execution of the machine
 */
static int perf_update_error(PINT_server_op *s_op, job_status_s* js_p)
{
    PINT_STATE_DEBUG("error");
    gossip_err("Error: stopping server performance monitoring.\n");

    PINT_perf_finalize();

    return(server_state_machine_complete(s_op));
}

/* perf_update_do_work()
 *
 * resets counters, updates metrices, etc- this is intended to be called
 * repeatedly on a regular interval
 */
static int perf_update_do_work(PINT_server_op *s_op, job_status_s* js_p)
{
    job_id_t tmp_id;
    struct server_configuration_s *user_opts = get_server_config_struct();

#if 0
    PINT_STATE_DEBUG("do_work");
#endif

    /* roll over to next set of statistics */
    PINT_perf_rollover();
	
    /* post another timer */
    return(job_req_sched_post_timer(user_opts->perf_update_interval,
	s_op,
	0,
	js_p,
	&tmp_id,
	server_job_context));
}




/*
 * Local variables:
 *  mode: c
 *  c-indent-level: 4
 *  c-basic-offset: 4
 * End:
 *
 * vim: ft=c ts=8 sts=4 sw=4 expandtab
 */

